package com.github.polpetta.mezzotre.telegram.callbackquery;

import com.github.polpetta.mezzotre.orm.model.CallbackQueryContext;
import com.github.polpetta.mezzotre.orm.model.TgChat;
import com.github.polpetta.mezzotre.orm.model.query.QTgChat;
import com.pengrad.telegrambot.model.Message;
import com.pengrad.telegrambot.model.Update;
import java.util.Optional;

public class Util {

  public static Optional<TgChat> extractChat(
      CallbackQueryContext callbackQueryContext, Update update) {
    return Optional.of(callbackQueryContext.getFields().getTelegramChatId())
        .map(Double::longValue)
        // If we're desperate, search in the message for the chat id
        .or(
            () ->
                Optional.ofNullable(update.callbackQuery().message())
                    .map(Message::messageId)
                    .map(Long::valueOf))
        .filter(chatId -> chatId != 0L && chatId != Long.MIN_VALUE)
        .flatMap(chatId -> new QTgChat().id.eq(chatId).findOneOrEmpty());
  }

  public static Optional<Integer> extractMessageId(Update update) {
    return Optional.ofNullable(update.callbackQuery().message()).map(Message::messageId);
  }
}
